function [SNR,SFDR,S,B20,B,tfy]= snr_estim(y,pb,k,n,OSR);
// y le signal a estimer 
// si pb>0 passe bas si pb=0passe bande sinon passe haut
//k emplacement du pic recherché cas normal k=0
//nbre de points autour du pic 
// OSR 


  L=length(y);
  w = window('kr',L,12)';       //3eme argument = 8.6 => blackman(L);
                    //Avec 3eme arg = 12 => SNDR optimise (test ADC 10 bit)
  U = (1/L)*sum(abs(w).^2);

  w= (1/((L*U)^(1/2)))*w;       //normalisation de la fenetre;


  spect=w.*y';
  tfy=fft(spect);
  c=round(L/OSR/2);
  if (pb==1)
    tfy=tfy(1:c);
    if (k==0)
      [maxim,k]=max(abs(tfy));
    end
    indmin=k-n;
    tfycar=tfy.*conj(tfy);
    S=sum(tfycar(indmin:k+n));
    B=sum(tfycar(1:c))-S;
    [maxim2,ind2] = max( abs([tfy(1:k-n) ; tfy(k+n:c)]) );
    indmin=ind2-n;
    if (indmin<1) 
        indmin=1; 
    end
    B2=sum(tfycar(indmin:ind2+n));
  end
   
  if (pb>1)
   tfy=tfy(1:c);
   tfycar=tfy.*conj(tfy);
   tfy_f=tfy;
   min_tfy=min(abs(tfy));
   S=0;
   for i=1:pb
      [maxim,k(i)]=max(abs(tfy_f));
      S=S+sum(tfycar(k(i)-n:k(i)+n));
      tfy_f(k(i)-n:k(i)+n)=min_tfy;
   end
   B=sum(tfycar(1:c))-S;
   B2=1;
  end
   
    
  if (pb<0)
    tfy=tfy(length(y)/2:-1:length(y)/2-c);
    if (k==0)
      [maxim,k]=max(abs(tfy));
    end
    tfycar=tfy.*conj(tfy);
    S=sum(tfycar(k-n:k+n));
    B=sum(tfycar(1:c))-S;
    [maxim2,ind2] = max(abs( [tfy(1:k-n) ; tfy(k+n:c)]) );
    B2=sum(tfycar(ind2-n:ind2+n));
  end
  if (pb==0)
    tfy=tfy(floor(length(y)/4-0.5*c):ceil(length(y)/4+c/2));
    if (k==0)
    [maxim,k]=max(abs(tfy));
    end
    S=0;
    for i=k-n:k+n
    S=S+(tfy(i)*conj(tfy(i)));
    end

    B=-S;
    for i=1:c
    B=B+(tfy(i)*conj(tfy(i)));
    end
    //[maxim2,ind2] = max(abs( [tfy(1:k-n) ; tfy(k+n:c)]) );
    //B2=0
    //for i=ind2-n:ind2+n
    // B2=B2+(tfy(i)*conj(tfy(i)));
    //   end
    B2=1;
  end

  SNR=10*log10(S/B);
  SFDR=10*log10(S/B2);
endfunction
