xdel(winsid());
funcprot(0);
exec("snr_estim.sci");  
L=60;// Ordre du filtre
nbitsfilter=6; //nombre de bits du quantificateur -ADC
Fc=20e3; //fréquence centrale du filtre
Fs=250e3; //%Fréquence d'échantillonnage
Ts=1/Fs;
N=1024;

t=0:Ts:(N-1)*Ts; //VecTeur Temps 
f=0:Fs/N:Fs/2-Fs/N; //VecTeur fréquence 
Signal_band=2e3;
Rolloff_band=10e3;
w = window('hn',N,12)';   //Fenetrage-Windowing

hn=eqfir(L+1,[0 Fc/Fs*0.7;Fc/Fs*0.95 Fc/Fs*1.05;Fc/Fs*1.3  1/2],[0  1 0],[1 0.0001 1]);
hn_quant=round(hn/max(hn)*(2^(nbitsfilter-1)-1)); //quantification du filtre
hn_quant_norm=hn_quant/(2^(nbitsfilter-1)/max(hn)); //normalisation après quantification


scf(1)
[hm,fr]=frmag(hn,N/2);
[hm_quant_norm,fr]=frmag(hn_quant_norm,N/2);
plot2d(f,20*log10(hm))
plot2d(f,20*log10(hm_quant_norm),2)
title('Reponse fréquentielle')
legend('filtre original','filtre quantifié') 
xlabel('fréquence(Hz)')
ylabel('Gain(dB)')

scf(2)
plot2d(hn_quant))
legend('filtre original','filtre quantifié') 
title('Reponse impulsionelle')
xlabel('')
ylabel('')
































