xdel(winsid());
funcprot(0);
fil_num=[0 -1 ]; //For a filter with a numerator 1-2Z^(-1)
fil_denum=[2 -1];//and a denumerator 1+3Z^(-1)+5Z^(-2)
fil_input=[zeros(1,10), 1 , zeros(1,10)]; //Vector of 21 samples for the input signal from t=-10 to t=10


[hm,fr]=frmag(fil_num,fil_denum,1000); //Calculating the frequency response of the filter


t=-10:10;


fil_output=filter(fil_num,fil_denum,fil_input);//Filtering the input by the filter impulse response


scf(1)
plot2d(t,fil_input,-2)
plot2d(t,fil_output,2)
legend(['input';'output']);
title('filter time domain output')
xlabel('time (Ts)')
ylabel('Output')


scf(2)
plot2d(fr,20*log10(abs((hm))))
title('filter frequency domain output')
xlabel('frequency')
ylabel('Gain (dB)')

scf(3)
numpoly=poly(fil_num(length(fil_num):-1:1),'z','coeff')
denompoly=poly(fil_denum(length(fil_denum):-1:1),'z','coeff')
firsl=syslin('d',numpoly,denompoly)
plzr(firsl)
